Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Data
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Imaging
Imports System.Windows.Navigation
Imports System.Windows.Shapes
Imports Syncfusion.Windows.SampleLayout
Imports System.ComponentModel
Imports Syncfusion.UI.Xaml.Schedule
Imports System.Globalization
Imports System.Threading
Imports Syncfusion.Windows.Shared
Imports Syncfusion.Windows.Controls.Navigation

Namespace CustomizationDemo
	''' <summary>
	''' Interaction logic for MainWindow.xaml
	''' </summary>

	#Region "MainWindow Class"

	Partial Public Class MainWindow
		Inherits SampleLayoutWindow
		#Region "Members"

		Friend SelectedAppointment As Appointment
		Friend AddDataContext As Object = Nothing
		Private copiedAppointment As Appointment
		Private CurrentSelectedDate As DateTime
		Private reminder As Reminder

		#End Region

		#Region "Properties"

		Private privateAppCollection As ScheduleAppointmentCollection
		Public Property AppCollection() As ScheduleAppointmentCollection
			Get
				Return privateAppCollection
			End Get
			Set(ByVal value As ScheduleAppointmentCollection)
				privateAppCollection = value
			End Set
		End Property

		#End Region

		#Region "Constructor"

		Public Sub New()
			InitializeComponent()
			customeEditor.DataContext = Me
			System.Threading.Thread.CurrentThread.CurrentUICulture = New System.Globalization.CultureInfo("en-US")
			Dim culture As CultureInfo
			culture = CultureInfo.CreateSpecificCulture("en-US")
			Thread.CurrentThread.CurrentCulture = culture
			AppCollection = New ScheduleAppointmentCollection()

			AppCollection.Add(New Appointment() With {.AppointmentImageURI = New BitmapImage(New Uri("pack://application:,,,/CustomizationDemo;Component/Assets/Hospital.png")), .ReadOnly = True, .StartTime = DateTime.Now.Date.AddDays(2), .EndTime = DateTime.Now.Date.AddDays(2).AddHours(4), .AppointmentTime = DateTime.Now.Date.AddHours(12).ToString("HH:mm tt"), .Subject = "Checkup", .Location = "Chennai", .AppointmentBackground = New SolidColorBrush(Color.FromArgb(255, 236, 12, 12)), .AppointmentType = Appointment.AppointmentTypes.Health, .ReminderTime = ReminderTimeType.TwoDays})
			AppCollection.Add(New Appointment() With {.AppointmentImageURI = New BitmapImage(New Uri("pack://application:,,,/CustomizationDemo;Component/Assets/Cake.png")), .StartTime = DateTime.Now.Date, .EndTime = DateTime.Now.Date.AddHours(4), .AppointmentTime = DateTime.Now.Date.AddMinutes(1).ToString("HH:mm tt"), .Subject = "My B'day", .AppointmentBackground = New SolidColorBrush(Color.FromArgb(255, 180, 31, 125)), .AppointmentType = Appointment.AppointmentTypes.Family, .ReminderTime = ReminderTimeType.OneHour})
			AppCollection.Add(New Appointment() With {.AppointmentImageURI = New BitmapImage(New Uri("pack://application:,,,/CustomizationDemo;Component/Assets/Team.png")), .StartTime = DateTime.Now.AddHours(4), .EndTime = DateTime.Now.AddHours(7), .AppointmentTime = DateTime.Now.AddHours(5.5).ToString("HH:mm tt"), .Subject = "Meeting", .AppointmentBackground = New SolidColorBrush(Color.FromArgb(255, 60, 181, 75)), .AppointmentType = Appointment.AppointmentTypes.Office, .ReminderTime = ReminderTimeType.FiveHours})
			Schedule.Appointments = AppCollection
			DataContext = Me

			AddHandler PreviewMouseLeftButtonUp, AddressOf MainWindow_PreviewMouseLeftButtonDown
			AddHandler Schedule.ContextMenuOpening, AddressOf Schedule_PopupMenuOpening
			AddHandler Schedule.MouseLeave, AddressOf Schedule_MouseLeave
			AddHandler Schedule.AppointmentEditorOpening, AddressOf Schedule_AppointmentEditorOpening
			AddHandler Schedule.Loaded, AddressOf Schedule_Loaded
			AddHandler Schedule.ReminderOpening, AddressOf Schedule_ReminderOpening
		End Sub

		#End Region

		#Region "Events"
		Private Sub Schedule_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
			customeEditor.AppType.ItemsSource = System.Enum.GetValues(GetType(Appointment.AppointmentTypes))
			customeEditor.AppType.SelectedIndex = 0
			AddHandler Schedule.PreviewMouseLeftButtonDown, AddressOf Schedule_PreviewMouseLeftButtonDown
			AddHandler Schedule.PreviewMouseWheel, AddressOf Schedule_PreviewMouseWheel
		End Sub

		Private Sub Schedule_PreviewMouseWheel(ByVal sender As Object, ByVal e As MouseWheelEventArgs)
			If RadialPopup IsNot Nothing Then
				RadialPopup.IsOpen = False
			End If
		End Sub

		Private Sub Schedule_PreviewMouseLeftButtonDown(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
			If RadialPopup IsNot Nothing Then
				RadialPopup.IsOpen = False
			End If
		End Sub

		Private Sub Schedule_ReminderOpening(ByVal sender As Object, ByVal e As ReminderControlOpeningEventArgs)
			e.Cancel = True
			Me.IsHitTestVisible = False
			If reminder Is Nothing Then
				reminder = New Reminder()
				reminder.Owner = Me
				AddHandler reminder.Closed, AddressOf reminder_Closed
				reminder.ReminderAppCollection = TryCast(e.RemindAppCollection, ScheduleAppointmentCollection)
				reminder.Show()
			End If
		End Sub

		Private Sub reminder_Closed(ByVal sender As Object, ByVal e As EventArgs)
			Me.IsHitTestVisible = True
		End Sub

		Private Sub Schedule_AppointmentEditorOpening(ByVal sender As Object, ByVal e As AppointmentEditorOpeningEventArgs)
			e.Cancel = True
			AddDataContext = New BindingClass() With {.CurrentSelectedDate = e.StartTime, .Appointment = e.Appointment}
			If e.Appointment IsNot Nothing Then
				EditAppointment()
			Else
				customeEditor.AppType.SelectedIndex = 0
				AddAppointment()
			End If
		End Sub

		Private Sub MainWindow_PreviewMouseLeftButtonDown(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
			If RadialPopup IsNot Nothing Then
				RadialPopup.IsOpen = False
			End If
		End Sub

		Private Sub Schedule_MouseLeave(ByVal sender As Object, ByVal e As MouseEventArgs)
			If (Not RadialPopup.IsMouseOver) AndAlso RadialPopup.IsOpen Then
				RadialPopup.IsOpen = False
			End If
		End Sub

		Private Sub Schedule_PopupMenuOpening(ByVal sender As Object, ByVal e As ContextMenuOpeningEventArgs)
			RadialPopup.IsOpen = False
			e.Cancel = True
			RadialPopup.IsOpen = True
			radialMenu.IsOpen = True
			If e.CurrentSelectedDate IsNot Nothing Then
				CurrentSelectedDate = CDate(e.CurrentSelectedDate)
			End If

			AddDataContext = New BindingClass() With {.CurrentSelectedDate = e.CurrentSelectedDate, .Appointment = e.Appointment}

			If e.Appointment IsNot Nothing Then
				For i As Integer = 0 To radialMenu.Items.Count - 1
					If i = 3 AndAlso copiedAppointment Is Nothing Then
						TryCast(radialMenu.Items(i), SfRadialMenuItem).IsEnabled = False
						TryCast(radialMenu.Items(i), SfRadialMenuItem).Opacity = 0.5
					Else
						TryCast(radialMenu.Items(i), SfRadialMenuItem).IsEnabled = True
						TryCast(radialMenu.Items(i), SfRadialMenuItem).Opacity = 1
					End If
				Next i

			Else
				TryCast(radialMenu.Items(1), SfRadialMenuItem).IsEnabled = False
				TryCast(radialMenu.Items(1), SfRadialMenuItem).Opacity = 0.5
				TryCast(radialMenu.Items(2), SfRadialMenuItem).IsEnabled = False
				TryCast(radialMenu.Items(2), SfRadialMenuItem).Opacity = 0.5
				TryCast(radialMenu.Items(5), SfRadialMenuItem).IsEnabled = False
				TryCast(radialMenu.Items(5), SfRadialMenuItem).Opacity = 0.5
				TryCast(radialMenu.Items(0), SfRadialMenuItem).IsEnabled = True
				If copiedAppointment IsNot Nothing Then
					TryCast(radialMenu.Items(3), SfRadialMenuItem).IsEnabled = True
					TryCast(radialMenu.Items(3), SfRadialMenuItem).Opacity = 1
				Else
					TryCast(radialMenu.Items(3), SfRadialMenuItem).IsEnabled = False
					TryCast(radialMenu.Items(3), SfRadialMenuItem).Opacity = 0.5
				End If

			End If
		End Sub

		#Region "Popup Menu Click Events"

		Private Sub pasteButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			RadialPopup.IsOpen = False
			If Me.copiedAppointment IsNot Nothing Then
				Dim app As Appointment = Me.copiedAppointment
				Dim appTimeDiff As TimeSpan = app.EndTime - app.StartTime
				Dim appointment As New Appointment()
				appointment.Subject = app.Subject
				appointment.Notes = app.Notes
				appointment.Location = app.Location
				appointment.ReadOnly = app.ReadOnly
				appointment.AppointmentBackground = app.AppointmentBackground
				appointment.AppointmentTime = Me.CurrentSelectedDate.ToString("HH:mm tt")
				appointment.AppointmentType = app.AppointmentType
				CustomEditor.SetImageForAppointment(appointment)
				appointment.StartTime = CDate(Me.CurrentSelectedDate)
				appointment.EndTime = (CDate(Me.CurrentSelectedDate)).Add(appTimeDiff)
				Schedule.Appointments.Add(appointment)
			End If
		End Sub

		Private Sub copyButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			copiedAppointment = CType(Schedule.SelectedAppointment, Appointment)
		End Sub

		Private Sub deleteButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			If Schedule.SelectedAppointment IsNot Nothing Then
				Schedule.Appointments.Remove(Schedule.SelectedAppointment)
			End If
		End Sub

		Private Sub editButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			EditAppointment()
		End Sub

		Private Sub addButton_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			AddAppointment()
		End Sub

		#End Region

		#End Region

		#Region "Editor Opening Methods"
		Private Sub EditAppointment()
			customeEditor.Visibility = Visibility.Visible
			Schedule.IsHitTestVisible = False
			customeEditor.DataContext = AddDataContext
			SelectedAppointment = TryCast((TryCast(AddDataContext, BindingClass)).Appointment, Appointment)
			customeEditor.AddReminder.Visibility = Visibility.Collapsed
			customeEditor.Reminder.Visibility = Visibility.Visible
			customeEditor.AddEndTimeMonth.Visibility = Visibility.Collapsed
			customeEditor.AddEndTime.Visibility = Visibility.Collapsed
			customeEditor.AddStartTimeMonth.Visibility = Visibility.Collapsed
			customeEditor.AddStartTime.Visibility = Visibility.Collapsed
			customeEditor.EditStartTimeMonth.Visibility = Visibility.Visible
			customeEditor.EditStartTime.Visibility = Visibility.Visible
			customeEditor.EditEndTimeMonth.Visibility = Visibility.Visible
			customeEditor.EditEndTime.Visibility = Visibility.Visible
			customeEditor.Delete.Visibility = Visibility.Visible
		End Sub

		Private Sub AddAppointment()
			customeEditor.Visibility = Visibility.Visible
			Schedule.IsHitTestVisible = False
			SelectedAppointment = Nothing
			customeEditor.AddReminder.SelectedIndex = 0
			customeEditor.AddEndTimeMonth.Visibility = Visibility.Visible
			customeEditor.AddEndTime.Visibility = Visibility.Visible
			customeEditor.AddStartTimeMonth.Visibility = Visibility.Visible
			customeEditor.AddStartTime.Visibility = Visibility.Visible
			If AddDataContext IsNot Nothing Then
				If (TryCast(AddDataContext, BindingClass)).CurrentSelectedDate IsNot Nothing Then
					customeEditor.AddStartTime.DateTime = (TryCast(AddDataContext, BindingClass)).CurrentSelectedDate.Value
					customeEditor.AddStartTimeMonth.SelectedDate = (TryCast(AddDataContext, BindingClass)).CurrentSelectedDate.Value
					customeEditor.AddEndTimeMonth.SelectedDate = (TryCast(AddDataContext, BindingClass)).CurrentSelectedDate.Value.AddHours(1)
					customeEditor.AddEndTime.DateTime = (TryCast(AddDataContext, BindingClass)).CurrentSelectedDate.Value.AddHours(1)
				ElseIf (TryCast(AddDataContext, BindingClass)).Appointment IsNot Nothing Then
					customeEditor.AddEndTimeMonth.SelectedDate = (TryCast((TryCast(AddDataContext, BindingClass)).Appointment, Appointment)).StartTime
					customeEditor.AddStartTimeMonth.SelectedDate = customeEditor.AddEndTimeMonth.SelectedDate
					customeEditor.AddEndTime.DateTime = (TryCast((TryCast(AddDataContext, BindingClass)).Appointment, Appointment)).StartTime.AddHours(1)
					customeEditor.AddStartTime.DateTime = customeEditor.AddEndTime.DateTime
				End If
			End If
			customeEditor.AddReminder.Visibility = Visibility.Visible
			customeEditor.Reminder.Visibility = Visibility.Collapsed
			customeEditor.EditStartTimeMonth.Visibility = Visibility.Collapsed
			customeEditor.EditStartTime.Visibility = Visibility.Collapsed
			customeEditor.EditEndTimeMonth.Visibility = Visibility.Collapsed
			customeEditor.EditEndTime.Visibility = Visibility.Collapsed
			customeEditor.Delete.Visibility = Visibility.Collapsed
			customeEditor.DataContext = AddDataContext
		End Sub
		#End Region
	End Class

	#End Region

	#Region "Appointment Class"

	Public Class Appointment
		Inherits ScheduleAppointment
		Implements INotifyPropertyChanged
		#Region "public properties"
		Private _imageuri As ImageSource
		Public Property AppointmentImageURI() As ImageSource
			Get
				Return _imageuri
			End Get
			Set(ByVal value As ImageSource)
				_imageuri = value
				OnPropertyChanged("AppointmentImageURI")
			End Set
		End Property

		Private privateAppointmentTime As String
		Public Property AppointmentTime() As String
			Get
				Return privateAppointmentTime
			End Get
			Set(ByVal value As String)
				privateAppointmentTime = value
			End Set
		End Property

		Private privateAppointmentType As AppointmentTypes
		Public Property AppointmentType() As AppointmentTypes
			Get
				Return privateAppointmentType
			End Get
			Set(ByVal value As AppointmentTypes)
				privateAppointmentType = value
			End Set
		End Property

		Public Enum AppointmentTypes
			Office
			Health
			Family
		End Enum


		#End Region

		Private Sub OnPropertyChanged(ByVal propertyName As String)
			Dim eventHandler = PropertyChangedEvent
			If eventHandler IsNot Nothing Then
				eventHandler(Me, New PropertyChangedEventArgs(propertyName))
			End If
		End Sub

		Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
	End Class

	#End Region

	#Region "CustomEditor Class"

	Public Class CustomEditor
		Inherits Control
		#Region "Constructor"
		Public Sub New()
			DefaultStyleKey = GetType(CustomEditor)
			UpdateLayout()

		End Sub
		#End Region

		#Region "Private Members"

		Public EditStartTimeMonth As DatePicker
		Public EditStartTime As DateTimeEdit
		Public EditEndTimeMonth As DatePicker
		Public EditEndTime As DateTimeEdit
		Public AddStartTimeMonth As DatePicker
		Public AddStartTime As DateTimeEdit
		Public AddEndTimeMonth As DatePicker
		Public AddEndTime As DateTimeEdit
		Public Subject As TextBox
		Public Notes As TextBox
		Public Location As TextBox
		Public Close As Button
		Public Save As Button
		Public ShowMorePanel As StackPanel
		Public editorPage As MainWindow
		Public Status As ComboBox
		Public Scroll As ScrollViewer
		Public AppType As ComboBox
		Public Reminder As ComboBox
		Public Delete As Button
		Public AddReminder As ComboBox
		Public AddStatus As ComboBox

		#End Region

		#Region "Override Methods"
		Public Overrides Sub OnApplyTemplate()
			editorPage = CType(DataContext, MainWindow)
			AddStartTimeMonth = TryCast(GetTemplateChild("addstartmonth"), DatePicker)
			AddStartTime = TryCast(GetTemplateChild("addstarttime"), DateTimeEdit)
			AddEndTimeMonth = TryCast(GetTemplateChild("addendmonth"), DatePicker)
			AddEndTime = TryCast(GetTemplateChild("addendtime"), DateTimeEdit)
			EditStartTimeMonth = TryCast(GetTemplateChild("editstartmonth"), DatePicker)
			EditStartTime = TryCast(GetTemplateChild("editstarttime"), DateTimeEdit)
			EditEndTimeMonth = TryCast(GetTemplateChild("editendmonth"), DatePicker)
			EditEndTime = TryCast(GetTemplateChild("editendtime"), DateTimeEdit)
			Subject = TryCast(GetTemplateChild("sub"), TextBox)
			Notes = TryCast(GetTemplateChild("notes"), TextBox)
			Location = TryCast(GetTemplateChild("where"), TextBox)
			Close = TryCast(GetTemplateChild("close"), Button)
			Save = TryCast(GetTemplateChild("save"), Button)
			Reminder = TryCast(GetTemplateChild("reminder"), ComboBox)
			Delete = TryCast(GetTemplateChild("delete"), Button)
			ShowMorePanel = TryCast(GetTemplateChild("showmorepanel"), StackPanel)
			Scroll = TryCast(GetTemplateChild("scroll"), ScrollViewer)
			Scroll.VerticalScrollBarVisibility = ScrollBarVisibility.Hidden
			Visibility = Visibility.Collapsed
			AddReminder = TryCast(GetTemplateChild("addreminder"), ComboBox)
			AppType = TryCast(GetTemplateChild("apptype"), ComboBox)
			AddHandler Close.Click, AddressOf Close_Click
			AddHandler Save.Click, AddressOf Save_Click
			AddHandler Delete.Click, AddressOf Delete_Click
            Reminder.ItemsSource = System.Enum.GetValues(GetType(ReminderTimeType))
			AddReminder.ItemsSource = Reminder.ItemsSource
			Reminder.SelectedIndex = 0
			AddReminder.SelectedIndex = Reminder.SelectedIndex
			DataContext = editorPage.AddDataContext
			Visibility = Visibility.Collapsed
			MyBase.OnApplyTemplate()
		End Sub
		#End Region

		#Region "Events"

		Private Sub Delete_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			Visibility = Visibility.Collapsed
			editorPage.Schedule.IsHitTestVisible = True
			If editorPage.SelectedAppointment IsNot Nothing Then
				editorPage.Schedule.Appointments.Remove(editorPage.SelectedAppointment)
			End If
		End Sub

		Private Sub Save_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			Visibility = Visibility.Collapsed
			editorPage.Schedule.IsHitTestVisible = True
			Dim appointment As Appointment
			If editorPage.SelectedAppointment Is Nothing Then
				appointment = New Appointment()
				Dim [date] As DateTime = CDate(AddStartTime.DateTime)
				appointment.StartTime = (CDate(AddStartTimeMonth.SelectedDate)).Date.Add(New TimeSpan([date].Hour, [date].Minute, [date].Second))
				Dim date1 As DateTime = CDate(AddEndTime.DateTime)
				appointment.ReminderTime = CType(AddReminder.SelectedItem, ReminderTimeType)
				appointment.EndTime = (CDate(AddEndTimeMonth.SelectedDate)).Date.Add(New TimeSpan(date1.Hour, date1.Minute, date1.Second))
			Else
				appointment = editorPage.SelectedAppointment
				Dim [date] As DateTime = CDate(EditStartTime.DateTime)
				appointment.ReminderTime = CType(Reminder.SelectedItem, ReminderTimeType)
				appointment.StartTime = (CDate(EditStartTimeMonth.SelectedDate)).Date.Add(New TimeSpan([date].Hour, [date].Minute, [date].Second))
				Dim date1 As DateTime = CDate(EditEndTime.DateTime)
				appointment.EndTime = (CDate(EditEndTimeMonth.SelectedDate)).Date.Add(New TimeSpan(date1.Hour, date1.Minute, date1.Second))
			End If
			appointment.Subject = Subject.Text
			appointment.Notes = Notes.Text
			appointment.Location = Location.Text
			If AppType.SelectedItem IsNot Nothing Then
				appointment.AppointmentType = CType(AppType.SelectedItem, Appointment.AppointmentTypes)
			Else
				appointment.AppointmentType = Appointment.AppointmentTypes.Family
			End If
			SetImageForAppointment(appointment)
			If editorPage.SelectedAppointment Is Nothing Then
				editorPage.Schedule.Appointments.Add(appointment)
			End If
		End Sub

		Public Shared Sub SetImageForAppointment(ByVal appointment As Appointment)
			Select Case appointment.AppointmentType
				Case Appointment.AppointmentTypes.Family
						appointment.AppointmentImageURI = New BitmapImage(New Uri("pack://application:,,,/CustomizationDemo;Component/Assets/Cake.png"))
						Exit Select
				Case Appointment.AppointmentTypes.Health
						appointment.AppointmentImageURI = New BitmapImage(New Uri("pack://application:,,,/CustomizationDemo;Component/Assets/Hospital.png"))
						Exit Select
				Case Appointment.AppointmentTypes.Office
						appointment.AppointmentImageURI = New BitmapImage(New Uri("pack://application:,,,/CustomizationDemo;Component/Assets/Team.png"))
						Exit Select
			End Select
		End Sub

		Private Sub Close_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
			Visibility = Visibility.Collapsed
			editorPage.Schedule.IsHitTestVisible = True
		End Sub

		#End Region
	End Class

	#End Region

	#Region "Binding Class"

	Public Class BindingClass
		Private privateCurrentSelectedDate As Nullable(Of DateTime)
		Public Property CurrentSelectedDate() As Nullable(Of DateTime)
			Get
				Return privateCurrentSelectedDate
			End Get
			Set(ByVal value As Nullable(Of DateTime))
				privateCurrentSelectedDate = value
			End Set
		End Property

		Private privateAppointment As Object
		Public Property Appointment() As Object
			Get
				Return privateAppointment
			End Get
			Set(ByVal value As Object)
				privateAppointment = value
			End Set
		End Property
	End Class

	#End Region
End Namespace
